-- Copyright (c) 2013 Cloudera, Inc. All rights reserved.
--
-- Version 12 of the CMON schema.
--
-- Change MySQL indexes on CMON_ACTIVITY.
-- Change the partition information table to have an explicit start time and
-- a type.
-- Create explicit time-range partitions if needed (done in java).
ALTER TABLE PARTITION_INFO ADD COLUMN BEGIN_TS BIGINT(20);
ALTER TABLE PARTITION_INFO ADD COLUMN TYPE INT;
-- '0' is the ordinal of the PERIODIC PartitionType enum value.
UPDATE PARTITION_INFO SET TYPE = 0 WHERE TYPE IS NULL;
ALTER TABLE PARTITION_INFO MODIFY COLUMN TYPE INT NOT NULL;

-- Create an index on the start and end time of activities.
CREATE INDEX IDX_ACTIVITY_START_TIME ON CMON_ACTIVITY(BEGIN_TS);
CREATE INDEX IDX_ACTIVITY_END_TIME ON CMON_ACTIVITY(END_TS);

-- For some reason this does not use a sequence. Let's fix it as it will
-- make our life when creating partitions easier.
ALTER TABLE CMON_ATTEMPT MODIFY COLUMN ID BIGINT(20) NOT NULL AUTO_INCREMENT;

-- Partition old data if necessary.
com.cloudera.cmon.firehose.db.PartitionOldAmonData
