-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04525 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=4525;

create table RELEASES (
  RELEASE_ID int8 not null,
  OPTIMISTIC_LOCK_VERSION int8 not null,
  PRODUCT varchar(255) not null,
  VERSION varchar(255) not null,
  primary key (RELEASE_ID)
);

create unique index IDX_UNIQUE_RELEASE on RELEASES
  (PRODUCT, VERSION);

alter table PARCELS
  add column RELEASE_ID int8 not null,
  add constraint FK_PARCEL_RELEASE
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID);

create index IDX_PARCEL_RELEASE on PARCELS (RELEASE_ID);

create table CLUSTER_MANAGED_RELEASES (
  CLUSTER_ID int8 not null,
  RELEASE_ID int8 not null,
  primary key (CLUSTER_ID, RELEASE_ID)
);

alter table CLUSTER_MANAGED_RELEASES
  add constraint FK_CLSTR_MNGD_RLS_CLSTR
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID);

create index IDX_CLSTR_MNGD_RLS_CLSTR on CLUSTER_MANAGED_RELEASES (CLUSTER_ID);

alter table CLUSTER_MANAGED_RELEASES
  add constraint FK_CLSTR_MNGD_RLS_RLS
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID);

create index IDX_CLSTR_MNGD_RLS_RLS on CLUSTER_MANAGED_RELEASES (RELEASE_ID);

create table CLUSTER_ACTIVATED_RELEASES (
  CLUSTER_ID int8 not null,
  RELEASE_ID int8 not null,
  primary key (CLUSTER_ID, RELEASE_ID)
);

alter table CLUSTER_ACTIVATED_RELEASES
  add constraint FK_CLSTR_ACTV_RLS_CLSTR
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID);

create index IDX_CLSTR_ACTV_RLS_CLSTR on CLUSTER_ACTIVATED_RELEASES (CLUSTER_ID);

alter table CLUSTER_ACTIVATED_RELEASES
  add constraint FK_CLSTR_ACTV_RLS_RLS
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID);

create index IDX_CLSTR_ACTV_RLS_RLS on CLUSTER_ACTIVATED_RELEASES (RELEASE_ID);
